#!/bin/bash
bin=`dirname "$0"`
bin=`cd "$bin"; pwd`

function err_pr {
	echo "$*" >&2
}
function print_nodelist {
	scontrol show hostname $SLURM_NODELIST
}
if [[ $# -ne 1 ]]; then
	err_pr "usage: frameworks-cleanup.sh framework"
	exit 1
fi
FW_NAME=$1
# include framework specific stuff here, such as files to modify (FRAMEWORK_CONF_FILES), file to enumerate slaves (FRAMEWORK_SLAVE_FILE), file to enumerate masters (FRAMEWORK_MASTER_FILE), path to scripts (FRAMEWORK_BIN_DIR)
local META_CONF=$FW_TEMPLATE_CONF_DIR/meta.conf
if [ -e $META_CONF ]; then
. $META_CONF
elif [ -e $bin/configs/$FW_NAME ]; then
. $bin/configs/$FW_NAME
else
err_pr "No file 'meta.conf' in $FW_TEMPLATE_CONF_DIR"
exit 1
fi
NODES=$SLURM_JOB_NUM_NODES
JOBID=$SLURM_JOB_ID
export FRAMEWORK_CONF_DIR="$HOME/cluster-conf-$JOBID/$FW_NAME"
FRAMEWORK_DATA_DIR=/scratch/$USER/cluster-$JOBID
FRAMEWORK_LOCAL_DIR=/tmp/$USER/cluster-conf-$JOBID
FRAMEWORK_MASTER_NODE=$(print_nodelist | awk '{print $1}' | sort -u | head -n 1)
FRAMEWORK_SLAVE_NODES=$(print_nodelist | awk '{print $1}' | sort -u | tail -n $(($NODES-1)) | sed ":a;N;s/\\n/,/g;ba")
#persist keyword replacements:
for node in $FRAMEWORK_MASTER_NODE $(cat $FRAMEWORK_CONF_DIR/$FRAMEWORK_SLAVE_FILE)
do
	srun -N1 -n1 --nodelist=$node "rm $FRAMEWORK_LOCAL_DIR"
done

